  .text
  .align
  .globl mcu_wait_bus_cycles

// extern "C" void mcu_wait_bus_cycles(unsigned int iCylces, unsigned int iAddr)

// Uses bus read cycles to delay.
// If cycles == 0 the function will be return immediately.
// The time base depends on chip select configuration!
// The chip select used for generating bus cyces depends on given address (iAddr),
mcu_wait_bus_cycles:
  teq r0, #0
  moveq pc, lr
mcu_wait_bus_cycles_lp:
// magic nops! <- never remove to avoid expensive bus synchronization cycles
  nop
  nop
  ldr r2, [r1]
  subs r0,r0,#1
 bne mcu_wait_bus_cycles_lp
 mov pc, lr
