/**
   Copyright (c) 2005,2006,2007,2008 by Conitec Datasysteme GmbH
   Written 2008 by Peer Georgi <georgi@conitec.com>

   License: GPL

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the
    Free Software Foundation, Inc.,
    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#ifndef __cG5PSCtrl_h
  #define __cG5PSCtrl_h

#include <memory>
#include <cG5ProductInfo.h>
class cG5AbstractPSCtrl;
class cG5PDIOCtrl;

class cG5PSCtrl
  {
//  public:
//    enum Supply { vls, vgate, vcomp, vcp1, vcp2, vcp3 };
  public:
    cG5PSCtrl(cG5PDIOCtrl*, cG5ProductInfo::ProductType);
    virtual ~cG5PSCtrl() throw();

    cG5AbstractPSCtrl& psCtrl();

  private:
    std::auto_ptr<cG5AbstractPSCtrl> mpImpl;
  };

#endif // __cG5PSCtrl_h
